
#include <dos.h>
#include <clib/alib_protos.h>
#include <proto/dos.h>
#include <proto/asl.h>
#include <proto/exec.h>
#include <proto/utility.h>
#include <proto/gadtools.h>
#include <proto/intuition.h>
#include <proto/rexxsyslib.h> 
#include <dos/exall.h>
#include <dos/dostags.h>
#include <exec/memory.h>
#include <exec/execbase.h>

/* catalog file */
#define  CATCOMP_NUMBERS
#include "includes/buildin.strings"

#define  _DOPUS_MODULE_DEF
#include <dopus/modules.h>

/* contains some replacements for string functions - by Dirk Stoecker */
#define  SDI_TO_ANSI
#include "special/sdi_std.h"

/********************************************************************/

#define VERSION_STRING "RndPic.module 1.3  Helmut Hummel\0"

#define COMMAND_0      "RndPicPrefs"
#define COMMAND_1      "RndPic"

#define CONFIG_FILE    "DOpus5:Settings/RndPic.prefs"
#define TEST_CONFIG    "T:RndPic.prefs"

/* precision flags */
#define CENTER_PIC     1 << 0
#define TILE_PIC       1 << 1
#define NO_FIT         1 << 3
#define BAD_FIT        1 << 4
#define MIDDLE_FIT     1 << 5
#define GOOD_FIT       1 << 6
#define BEST_FIT       1 << 7

#define RANDOM_ENABLED 1 << 8

/* other flags */
#define COPY_MODE      1 << 0
#define CYCLE_MIDDLE   1 << 8 
#define STARTUP        1 << 9

/********************************************************************/

/* the block which contains the paths and flags */
typedef struct
{   
    ULONG flags;
    char path[256];   
}   RndPrefsData;

/* timeblock for command mode */ 
typedef struct
{
    ULONG startdelay;
    ULONG middledelay;
}   DelayBlock;

/* summay of all prefs */
typedef struct
{
    RndPrefsData rpd[4];
    DelayBlock   db;
}   PrefsData;

/* data for the process to send the commands */
typedef struct
{
    ULONG a4;
    struct Library *library;
    struct Library *module;
    IPCData *ipc;
    PrefsData pd;
    struct MsgPort *source;
    struct MsgPort *receiver;
    struct RexxMsg *rmsg;
}   PassData;

/* preferences data */
typedef struct
{
    IPCData *ipc;
    ULONG running;
    ULONG misc;
    
    struct Window *prefswin;
    ObjectList *olist;        // the global list
    ObjectList *modelist;     // the swap list
    GL_Object *cur;
    
    PopUpMenu popmenu;
    PopUpItem *popitem;
    
    struct Gadget *gads[3];
    
    struct IntuiMessage *imsg;
       
    PrefsData pd;
       
    char buffer[256];
    char puffer[256];
    DOpusCallbackInfo dc;
}   RPData;
    
/* data for the "working" process */
typedef struct
{
    PrefsData pd;
    Att_List *dirlist;
    
    struct FileInfoBlock *fib;
    BPTR lock;
    LONG more;
    ULONG count;
            
    struct ExAllData *ead;
    struct ExAllControl *eac;
            
    char buffer[256];
    char puffer[256];
    char mem[4096]; 
       
    struct MsgPort *rport;
    IPCData *sender;
          
}   RndData;

extern APTR mempool; // from modinit.c

    
